
var Fresh; if (!Fresh) Fresh = {};

Fresh.MenuPanel = function(preferences) {
	this.currentTheme = 'aero';
	Fresh.MenuPanel.superclass.constructor.call(this, {
		region: 'north',
		margins: '0 0 0 0',
		tbar: [{
			text: 'Main',
			menu: {
				id: 'mainMenu',
				items: [
	        	{
	        		text: 'Refresh all feeds  (R)',
					handler: Fresh.Reader.onRefreshAll,
					scope: Fresh.Reader
	        	},	            
	        	{
	        		text: 'Mark all feeds read (A)',
					handler: Fresh.Reader.onMarkAllRead,
					scope: Fresh.Reader
	        	},'-',
				{
		        	text: 'Import OPML',
					handler: Fresh.Reader.onImportOpml,
					scope: Fresh.Reader
	        	},
	        	{
	        		text: 'Export OPML',
					handler: Fresh.Reader.onExportOpml,
					scope: Fresh.Reader
	        	},'-',
	        	{
	        		text: 'Empty cache',
					handler: Fresh.Reader.emptyCache,
					scope: Fresh.Reader
	        	}, {
	        		text: 'Reset window state',
					handler: Fresh.Reader.resetState,
					scope: Fresh.Reader
	        	}]
			}
		},'-',{
			text: 'Preferences',
			tooltip : {title: 'Preferences dialog', text: 'Personalize the application'},
			handler: this.onPreferencesClick,
			scope: this
		},'-',{
			text:'Help',
			menu: {
				id: 'helpMenu',
				items: [{
		        		text: 'Key navigation',
						handler:  this.onHelpClick,
						scope: this
		        	},'-', {
		        		text: 'View source',
						handler:  this.onViewSource,
						scope: this
		        	},
		        	{
		        		text: 'About',
						handler: this.onAboutClick,
						scope: this
		        }]
			}
		}]
	});
	// preferences
	this.preferences = preferences;
	this.prefWin = new Fresh.PreferencesWindow(preferences);
	this.prefWin.on('prefsave', this.savePreferences, this);
	// about
	this.aboutWin = new Fresh.AboutWindow();
	// help
	this.helpWin = new Fresh.HelpWindow();
}

Ext.extend(Fresh.MenuPanel, Ext.Panel, {
	onThemeClick: function(item, checked) {
		runtime.trace("Theme Click: " + item.id);
	},
	
	onPreferencesClick: function() {
		this.prefWin.show();
	},
	
	savePreferences: function(prefs) {
		
		this.preferences.savePreferences(prefs);
	},
	
	onHelpClick: function() {
		this.helpWin.show();
	},
	
	onViewSource: function() {
		air.SourceViewer.getDefault().viewSource();
	},
	
	onAboutClick: function() {
		this.aboutWin.show();
	}
});
